<template lang="pug">

.container
  .activity__block
    app-create-link(
    :slug="createEventSlug"
    :linkText="linkText")

  app-data-grid(
    :loading="pageLoading"
    :dataArray="news.news"
    :changePage="changePage"
    :columnNameWidth="dataGridLinkWidth"
    :linkName="dataGridLinkName"
    :activityView="true"
    :propDataGrid='propDataGrid'
    :deletePermission="'isFormCreator'"
    :editPermission="'isFormEditor'"
    @delete-item="deleteNewsItem"
    :paginationObj="news.pagination"
    :childComponent="'news/'")

</template>

<script>
import CreateLink from '../../../components/admin/CreateLink.vue';
import DataGrid from '../../../components/admin/DataGrid.vue';

export default {
  layout: 'admin',
  name: 'AdminNews',
  components: {
    'app-create-link': CreateLink,
    'app-data-grid': DataGrid
  },
  async asyncData(app) {
    let { data } = await app.$axios.get('/api/v1/news', {
      params: {
        sort: {
          id: -1
        },
        pagination: {
          perPage: 10,
          currentPage: 1
        }
      }
    });
    return { news: data };
  },
  data() {
    return {
      perPage: 10,
      page: 1,
      pageLoading: false,
      linkText: 'новость',
      dataGridLinkName: {
        name: 'Заголовок новости',
        attrName: 'heading'
      },
      propDataGrid: [
        {
          name: 'created_at',
          label: 'Дата создания',
          width: '220'
        }
      ],
      dataGridLinkWidth: '530',
      createEventSlug: '/admin/news/new-news',
      formLoad: true
    };
  },
  created() {
    this.$store.commit('pages', []);
    this.$store.commit('headingTitle', 'Новости');
    this.$store.commit('publicLink', '/news');
    this.$store.commit('id', null);
  },
  mounted() {
    this.createDate();
    this.$nextTick(() => {
      window.addEventListener('resize', this.getWindowWidth);
    });

    this.getWindowWidth();
  },
  methods: {
    createDate() {
      if (this.news.news.length) {
        this.news.news.forEach(item => {
          item.created_at = `${this.$moment(item.created_at).format(
            'D.MM.YY'
          )}, в ${this.$moment(item.created_at).format('H:mm')}`;
        });
      }
    },
    deleteNewsItem(id) {
      this.pageLoading = true;
      let imagePath = [];
      let counter = 0;
      let imageDelete = () => {
        console.log(imagePath, counter);
        this.$axios
          .delete(`/api/v1/img?photo=${imagePath[counter]}`)
          .then(() => {
            if (counter < imagePath.length - 1) {
              counter++;
              imageDelete();
            } else {
              this.$axios
                .get('/api/v1/news', {
                  params: {
                    sort: {
                      id: -1
                    },
                    pagination: {
                      perPage: this.perPage,
                      currentPage: this.page
                    }
                  }
                })
                .then(data => {
                  this.rewriteNewsData(data);
                  this.$message.warning('Успешно удалено!');
                });
            }
          });
      };
      this.$axios
        .delete(`/api/v1/news/${id}`)
        .then(data => {
          if (data.data.photos.length) {
            imagePath = data.data.photos;
          }
          if (data.data.cover) {
            imagePath.push(data.data.cover);
          }
          if (imagePath.length) {
            imageDelete();
          } else {
            this.$axios
              .get('/api/v1/news', {
                params: {
                  sort: {
                    id: -1
                  },
                  pagination: {
                    perPage: this.perPage,
                    currentPage: this.page
                  }
                }
              })
              .then(data => {
                this.rewriteNewsData(data);
                this.$message.warning('Успешно удалено!');
              });
          }
        })
        .catch(() => {
          this.pageLoading = false;
          this.$message.error('Ошибка удаления!');
        });
    },
    rewriteNewsData(data) {
      this.news = data.data;
      let pagination = data.data.pagination;
      if (
        Math.ceil(pagination.totalPageCount / pagination.perPage) <
          pagination.currentPage &&
        pagination.currentPage - 1 > 0
      ) {
        this.changePage(pagination.currentPage - 1);
      }
      this.createDate();
      this.pageLoading = false;
    },
    changePage(value) {
      this.pageLoading = true;
      this.page = value;
      this.$axios
        .get('/api/v1/news', {
          params: {
            sort: {
              id: -1
            },
            pagination: {
              perPage: this.perPage,
              currentPage: value
            }
          }
        })
        .then(data => {
          this.news = data.data;
          this.createDate();
          this.pageLoading = false;
        });
    },
    getWindowWidth() {
      if (this.$parent.$currentViewport.label === 'desktop-medium') {
        this.dataGridLinkWidth = '350';
      } else if (
        this.$parent.$currentViewport.label === 'mobile' ||
        this.$parent.$currentViewport.label === 'tablet'
      ) {
        this.dataGridLinkWidth = '250';
      } else {
        this.dataGridLinkWidth = '530';
      }
    }
  }
};
</script>
